freeslot("MT_CHAOSKNUXAURA", "S_CHAOSAURA1", "sfx_what")

local blowup_list = {MT_EGGROBO1, MT_SALOONDOOR, MT_SALOONDOORCENTER, MT_BIGMACE, MT_SMALLMACE}
local cactus_list = {MT_CACTI1, MT_CACTI2, MT_CACTI3, MT_CACTI4, MT_CACTI5, MT_CACTI6, MT_CACTI7, MT_CACTI8, MT_CACTI9, MT_CACTI10, MT_CACTI11}

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
        if (player.mo.skin ~= "knuckles")
            if (player.chaos_aura and player.chaos_aura.valid)
                player.chaos_aura.flags2 = $|MF2_DONTDRAW
                player.pflags = $&~PF_GODMODE
                player.jumpfactor = skins[player.mo.skin].jumpfactor               
                P_RemoveMobj(player.chaos_aura)
            end
        end
		if player.mo.skin == "knuckles" and player.smhyper
        
        player.dashspeed = 300*FRACUNIT //WTF SPEED
        
        local pmo = player.mo
        
        if not player.omegadash
            player.omegadash = false
        end
        
        if player.omegadash == true
        and player.pflags & PF_SPINNING
        and not (player.pflags & PF_STARTDASH)
            S_StartSound(pmo,sfx_nuexp)
            for a=1,100 do
                local explode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
                explode.colorized = true
                explode.color = SKINCOLOR_EMERALD
                explode.blendmode = AST_ADD
                explode.momx = P_RandomRange(-32768, 32767) * 64
                explode.momy = P_RandomRange(-32768, 32767) * 64
                explode.momz = P_RandomFixed() * 64
            end
        end               
        
        if player.pflags & PF_STARTDASH
            player.omegadash = true
        else
            player.omegadash = false
        end
        
        if player.pflags & PF_STARTDASH
        and P_IsObjectOnGround(player.mo)
            P_StartQuake(40*FRACUNIT, TICRATE/4)
        end
            
        if not player.chaosflight
            player.chaosflight = false
        end

        if ((player.cmd.buttons & BT_JUMP) or (player.cmd.buttons & BT_USE))
            player.holdingflightbutton = true
        else
            player.holdingflightbutton = false
        end
        
        if player.cmd.buttons & BT_CUSTOM1
        and (player.pflags & PF_JUMPED or player.chaosflight or (pmo.state == S_PLAY_FALL or pmo.state == S_PLAY_SPRING))
        and not P_PlayerInPain(player)
        and not player.powers[pw_carry]
        and not (player.exiting)
            if (player.tappingtossflag ~= true)
                if (player.chaosflight == false)
                    player.chaosflight = true
                else
                    player.chaosflight = false
                    pmo.state = S_PLAY_FALL
                    pmo.flags = $ &~MF_NOGRAVITY
                end
            end
        end
        
        if player.cmd.buttons & BT_CUSTOM1
            player.tappingtossflag = true
        else
            player.tappingtossflag = false
        end
        
                if (P_IsObjectOnGround(pmo))
                and player.chaosflight
                    pmo.flags = $ &~MF_NOGRAVITY
                    player.chaosflight = false
                end
                
                if player.chaosflight
                    player.pflags = $|PF_CANCARRY
                else
                    player.pflags = $&~PF_CANCARRY
                end
        
            
                if player.chaosflight
                if (player.speed == 0 and (pmo.momz == 0))
                    pmo.state = S_PLAY_STND
                elseif (player.speed != 0)
                    pmo.state = S_PLAY_GLIDE
                elseif (pmo.momz > 0)
                    pmo.state = S_PLAY_SPRING
                elseif (pmo.momz < 0)
                    pmo.state = S_PLAY_FALL
                end
                pmo.flags = $|MF_NOGRAVITY
                player.pflags = $&~PF_JUMPED
                
                if (player.cmd.forwardmove)
                or (player.cmd.sidemove)
                    P_InstaThrust(pmo,
                    (player.cmd.angleturn << 16) + R_PointToAngle2(0, 0, player.cmd.forwardmove << 16, -player.cmd.sidemove << 16),
                    FixedMul(player.normalspeed, pmo.scale))
                end
                
                if (player.cmd.buttons & BT_JUMP)
                    if (pmo.momz < 20*FRACUNIT)
                        P_SetObjectMomZ(pmo, 10*FRACUNIT, true)
                        player.holdingflightbutton = true
                    end
                end
                if (player.cmd.buttons & BT_USE)
                    if (pmo.momz > -20*FRACUNIT)
                        P_SetObjectMomZ(pmo, -15*FRACUNIT, false)
                        player.holdingflightbutton = true
                    end
                end
            end
            if player.chaosflight
                if not (player.cmd.forwardmove or player.cmd.sidemove)
                    pmo.momx = 0
                    pmo.momy = 0
                end
                if (player.holdingflightbutton ~= true)
                    if ((pmo.momz >= -pmo.scale) and (pmo.momz <= pmo.scale))
                        pmo.momz = 0
                    elseif not ((pmo.momz >= -pmo.scale) and (pmo.momz <= pmo.scale))
                        if (player.holdingflightbutton ~= true)
                            pmo.momz = 0
                        end
                    end
                end	
            end
        
            if player.hugger == nil
                player.hugger = 0
            end
            if (pmo.momx or pmo.momy or pmo.momz)
            and (player.hugger)
                player.hugger = 0
            end
			local normalspeed = skins["knuckles"].normalspeed
			local hyperspeed = skins["knuckles"].normalspeed*2
            
            if player.almightystomp == nil
                player.almightystomp = false
            end
            if player.divinepowerstomp == nil
                player.divinepowerstomp = false
            end
            if pmo.state == S_PLAY_FALL
                if (player.pflags & PF_THOKKED)
                    player.almightystomp = true
                else
                    player.almightystomp = false
                end
            end
            
            if not (player.pflags & PF_THOKKED)
                player.almightystomp = false
            end
            
            if player.almightystomp
                if (pmo.eflags & MFE_SPRUNG)
                    S_StartSound(pmo, sfx_sprong)
                    player.pflags = $&~PF_JUMPED&~PF_THOKKED
                    pmo.state = S_PLAY_SPRING
                    pmo.momz = $*50/33
                    player.almightystomp = false
                end
            end
            
            if (pmo.storedmomz != nil) and (pmo.storedmomz <= -30*FRACUNIT)
            and not (player.powers[pw_carry])
                player.divinepowerstomp = true
            end            
            
            if (pmo.state == S_PLAY_GLIDE_LANDING) // Almighty Stomp
            and (pmo.eflags & MFE_JUSTHITFLOOR)
                if not player.divinepowerstomp
                    P_NukeEnemies(pmo, player.mo, 4214*FRACUNIT)
                    P_StartQuake(90*FRACUNIT, TICRATE/4)
                    S_StartSound(pmo, sfx_kc40)
                    S_StartSound(pmo, sfx_s3k5f)
                    player.almightystomp = false
                else
                    P_NukeEnemies(pmo, player.mo, 12404*FRACUNIT)
                    P_StartQuake(120*FRACUNIT, TICRATE*2)
                    S_StartSound(pmo, sfx_kc40)
                    S_StartSound(pmo, sfx_s3k5f)
                    S_StartSound(pmo,sfx_nuexp)
                    for a=1,200 do
                        local explode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
                        explode.colorized = true
                        explode.color = SKINCOLOR_EMERALD
                        explode.blendmode = AST_ADD
                        explode.momx = P_RandomRange(-32768, 32767) * 64
                        explode.momy = P_RandomRange(-32768, 32767) * 64
                        explode.momz = P_RandomFixed() * 64
                    end
                    for a=1,60 do
                        local smoke = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_TNTDUST)
                        smoke.colorized = true
                        smoke.color = SKINCOLOR_EMERALD
                        smoke.momx = P_RandomRange(-327, 326) * 32
                        smoke.momy = P_RandomRange(-326, 325) * 32
                        smoke.momz = P_RandomFixed() * 32
                    end
                    player.divinepowerstomp = false
                    player.almightystomp = false
                end
                local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
				if sectorthing.valid then
                    for fof in sectorthing.ffloors()
                        if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
                        and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale) then
                            EV_CrumbleChain(player.sectorthing, fof)
                        end
                    end
                end
            end
                
            
            if player.climbing
                if (pmo.state == S_PLAY_CLIMB)
                    if (pmo.tics >= 2)
                        pmo.tics = 2
                    end
                end
                if (player.cmd.forwardmove)
                pmo.momz = $*3
                end
                if (player.cmd.sidemove)
                pmo.momx = $*3
                pmo.momy = $*3
                end
            end
			
			if (S_MusicName() == "_super")
				if (player.hyper_music == true)
					P_PlayJingleMusic(player, "CHSKNX", 0, true, JT_OTHER)
				end
			end
				player.normalspeed = hyperspeed
                player.pflags = $|PF_GODMODE
				if player.hyper_colorized
					pmo.color = (SKINCOLOR_CHAOS_KNUX1 + abs( ( (leveltime >> 1) % 9) - 4))
				end
                if not(player.chaos_aura and player.chaos_aura.valid)
                    player.chaos_aura = P_SpawnMobjFromMobj(pmo, 0, 0, 0, MT_CHAOSKNUXAURA)
                    player.chaos_aura.state = S_CHAOSAURA1
                end
                if (player.chaos_aura and player.chaos_aura.valid)
                    player.chaos_aura.color = SKINCOLOR_CHAOS_KNUX1
                    player.chaos_aura.scale = pmo.scale * 2
                    player.chaos_aura.flags = $|MF_MISSILE
                    player.chaos_aura.flags2 = $&~MF2_DONTDRAW|MF2_SCATTER
                    player.chaos_aura.colorized = true
                    player.chaos_aura.blendmode = AST_ADD
                    player.chaos_aura.target = pmo
                end
				local electric = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-20, 20) * FRACUNIT, P_RandomRange(-20, 20) * FRACUNIT, P_RandomRange(0, 50) * FRACUNIT, MT_WATERZAP)
				electric.color = pmo.color
				electric.frame = $|FF_FULLBRIGHT
				electric.colorized = true
				if (player.speed > 2*FRACUNIT or pmo.momz > 2*FRACUNIT or pmo.momz < -1*FRACUNIT)
				and (leveltime % 2 == 1)
					local ghost1 = P_SpawnGhostMobj(pmo)
					ghost1.color = pmo.color
					ghost1.colorized = true
					ghost1.rollangle = pmo.rollangle
					ghost1.fuse = 5
					ghost1.blendmode = AST_ADD
					ghost1.eflags = pmo.eflags & MFE_VERTICALFLIP
			end	
		end
	end
end)

addHook("ShouldJingleContinue", function(player, musname)
    if musname != "chsknx" return end
    if (player.smhyper)
    and (player.mo.skin == "knuckles")
        return true
    else
        return false
    end
end)

local windows11
addHook("PreThinkFrame", function(r)
	windows11 = S_GetMusicPosition()
end)

addHook("MusicChange", function(iam, confused)
	if (gamestate != GS_LEVEL) or (consoleplayer.hyper_music ~= true) return end
	if (consoleplayer and consoleplayer.mo 
	and consoleplayer.mo.valid and consoleplayer.mo.health
	and consoleplayer.smhyper)
	and (confused == "_shoes" or confused == "_inv" or confused == "_minv" or confused == mapmusname)
		if iam == "chsknx"
			return true
		else
			return "chsknx", 0, true, windows11
		end
	end
end)

local function destroyAnything(p, mobj)
    local player = p.player
    if not player.smhyper or (not ((p.skin == "knuckles"))) then return end
    if (mobj and mobj.valid)
    and not (p.z > mobj.z+mobj.height) 
    and not (mobj.z > p.z+p.height)
    and not (mobj.info.mass == 2006)
    and (mobj.type == MT_SALOONDOOR or mobj.type == MT_SALOONDOORCENTER
    or mobj.type == MT_FAKEMOBILE or mobj.type == MT_TURRET
    or mobj.type == MT_BIGMACE or mobj.type == MT_SMALLMACE or mobj.type == MT_EGGMOBILE4_MACE or (mobj.type == MT_SPIKEBALL)
    or (mobj.type >= MT_CACTI1 and mobj.type <= MT_CACTISMALLSEG))
        S_StartSound(p, sfx_brakrx)
        local explode = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_BOSSEXPLODE)
        explode.scale = mobj.scale*2
        explode.colorized = true
        explode.color = SKINCOLOR_EMERALD
        explode.blendmode = AST_ADD
        P_StartQuake(65*FRACUNIT, 1)
        mobj.flags2 = $|MF2_DONTDRAW
        P_RemoveMobj(mobj)
    end
	if not p.player.smhyper or not (mobj.valid) or (not ((p.skin == "knuckles") or (p.player.powers[pw_carry] == CR_NIGHTSMODE)) or ((not ((mobj.flags & MF_BOSS) or (mobj.flags & MF_ENEMY) or (mobj.flags & MF_MONITOR))) or (p.z > mobj.z+mobj.height) or (mobj.z > p.z + p.height) or (mobj.type == MT_EGGROBO1) or (mobj.type == MT_ROSY))) then return end
    if (mobj.health)
        if not ((mobj.type == MT_EGGROBO1)) then
            P_KillMobj(mobj, p, p)
        end
    end
	return false
end
local function blowUp(p, mobj)
    local player = p.player
	if not p.player.smhyper or (not ((p.skin == "knuckles") or (mobj.type == MT_ROSY))) then return end
    if (mobj and mobj.valid)
    and not (p.z > mobj.z+mobj.height) 
    and not (mobj.z > p.z+p.height)
    and not (mobj.info.mass == 2006)
    and (mobj.type == MT_SALOONDOOR or mobj.type == MT_SALOONDOORCENTER
    or mobj.type == MT_BIGMACE or mobj.type == MT_SMALLMACE)
        local explode = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_BOSSEXPLODE)
        explode.scale = mobj.scale*2
        explode.colorized = true
        explode.color = SKINCOLOR_EMERALD
        explode.blendmode = AST_ADD
        P_StartQuake(70*FRACUNIT, TICRATE/4)
        mobj.flags2 = $|MF2_DONTDRAW
        P_AddPlayerScore(player, 100)
        P_RemoveMobj(mobj)
    end
	return false
end
addHook("MobjCollide", destroyAnything, MT_PLAYER)
addHook("MobjMoveCollide", destroyAnything, MT_PLAYER)

//My, my, obvious
addHook("MobjDeath", function(buu, i, gohan)
	if buu and buu.valid and gohan and gohan.player and (gohan.player.smhyper and gohan.skin == "knuckles")
		local explode = P_SpawnMobjFromMobj(buu, 0,0,0, MT_BOSSEXPLODE)
        S_StartSound(buu.target, sfx_brakrx)
        explode.scale = buu.scale*2
        explode.colorized = true
        explode.color = SKINCOLOR_EMERALD
        explode.blendmode = AST_ADD
        P_StartQuake(70*FRACUNIT, TICRATE/4)
        buu.flags2 = $|MF2_DONTDRAW
        P_AddPlayerScore(gohan.player, 100)
        P_RemoveMobj(buu)
		return true
	end
end, MT_EGGROBO1)

addHook("MobjDeath", function(beerus, i, ssj3goku)
		if (beerus.type == MT_MINECART)
		and beerus.target  and beerus.target.player and beerus.target.player.smhyper and beerus.target.health 
		and (gametype == GT_COOP) --'cause cannot break minecart doors outside of COOP.
			beerus.target.player.powers[pw_carry] = 0
			beerus.target.momx = beerus.momx
			beerus.target.momy = beerus.momy
			P_SetObjectMomZ(beerus.target, 6*FRACUNIT, true)
			beerus.target = nil
		end
end, MT_MINECART)

//RIP Amy 2019-2022
addHook("MobjThinker", function(rosy)
	if (rosy.state == S_ROSY_HUG) and rosy.target and rosy.target.skin == "knuckles"
        local player = rosy.target.player
        player.hugger = 1
         if (player.cmd.buttons & BT_CUSTOM1)
         and (rosy and rosy.valid)
            S_StartSound(rosy.target, sfx_brakrx)
            local explode = P_SpawnMobjFromMobj(rosy, 0,0,0, MT_BOSSEXPLODE)
            explode.scale = rosy.scale*2
            explode.colorized = true
            explode.color = SKINCOLOR_EMERALD
            explode.blendmode = AST_ADD
            P_StartQuake(60*FRACUNIT, TICRATE/4)
            P_RemoveMobj(rosy)
            P_AddPlayerScore(player, 100)
            player.hugger = 0
        end
	end
end, MT_ROSY)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		local mo = player.mo
		if not (mo and mo.valid and mo.skin == "knuckles") continue end
		if (player == nil) or (player.playerstate != PST_LIVE) continue end
		
		if (mo.previousx == nil) or (mo.previousy == nil) or (mo.previousz == nil)
			mo.previousx = mo.x
			mo.previousy = mo.y
			mo.previousz = mo.z
		end
        if (mo.prevstate == nil)
			mo.prevstate = mo.state
		end
         if (mo.storedmomz == nil)
			mo.storedmomz = mo.momz
		end
        if not player.smhyper
            if (player.chaos_aura and player.chaos_aura.valid)
                P_RemoveMobj(player.chaos_aura)
            end
        end
		if player.smhyper
        local pmo = mo
           if (player.chaos_aura and player.chaos_aura.valid)
                player.chaos_aura.color = pmo.color
                player.chaos_aura.scale = pmo.scale * 2
                player.chaos_aura.flags = $|MF_MISSILE
                player.chaos_aura.flags2 = $&~MF2_DONTDRAW|MF2_SCATTER
                player.chaos_aura.eflags = pmo.eflags
                player.chaos_aura.colorized = true
                player.chaos_aura.blendmode = AST_ADD
                A_CapeChase(player.chaos_aura, 0, 0)
            end
		end
		mo.previousx = mo.x
		mo.previousy = mo.y
		mo.previousz = mo.z
        mo.storedmomz = mo.momz
        mo.prevstate = mo.state
	end
end)

local function hudthingas(v, player, cam)
	if (player.mo and player.mo.skin == "knuckles" and player.smhyper)
    and player.hugger ~= nil and player.hugger == 1
        v.drawString(160, 180+10, "Press c1 to blow up the trash", V_GREENMAP|V_PERPLAYER, "small-center")
	end
end
hud.add(hudthingas, player)