//I AM KNUX, AND I CHUCKLE
local DIG_TIME = 9*TICRATE

freeslot("S_PLAY_DIG1", "S_PLAY_DIGU")

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	
	
		if player.mo.skin == "knuckles"
			if player.digging == nil
				player.digging = 0
			end
			if player.spike_breaktime == nil
				player.spike_breaktime = 0
			end
			if player.digtime == nil
				player.digtime = DIG_TIME
			end
			if player.tossflagging == nil
				player.tossflagging = false
			end
			if player.spike_breaktime
				player.spike_breaktime = $ - 1
			end
            if player.chaoscooldown == nil
                player.chaoscooldown = false
			end
            if player.chaoscooldown
				player.chaoscooldown = $ - 1
			end
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	 if player.mo and player.mo.valid
		if player.mo.skin == "knuckles" and player.playerstate == PST_LIVE
        
        local jumpheight = skins["knuckles"].jumpfactor
        local chaosjumpheight = skins["knuckles"].jumpfactor*2
        
        if player.smhyper 
            player.jumpfactor = chaosjumpheight
        else
            player.jumpfactor = jumpheight
        end
		
		local knux = player.mo
		local knuckles = player
		local height = skins["knuckles"].height
		
				if knuckles.can_regentime == nil
					knuckles.can_regentime = true
				end
				
				if (knuckles.can_regentime == false) and not knuckles.digging
					if ((leveltime % TICRATE == 0))
						knuckles.can_regentime = true
					end
				end
				
				if (knuckles.can_regentime == true) and knuckles.digtime < DIG_TIME and not knuckles.digging
					if ((leveltime % 15 == 0))
						knuckles.digtime = $ + TICRATE
					end
				end
			

				if knuckles.cmd.buttons & BT_TOSSFLAG
				and not knuckles.exiting
				and knuckles.digtime > 0
				and not knuckles.powers[pw_nocontrol]
				and not (knuckles.pflags & PF_STASIS)
				and (knuckles.pflags & PF_JUMPED and knux.state == S_PLAY_JUMP)
				and not knuckles.digging
					knuckles.digging = 1
					knuckles.can_regentime = false
					knuckles.tossflagging = true
				end
				if not (knuckles.cmd.buttons & BT_TOSSFLAG)
				and (knuckles.tossflagging)
					knuckles.tossflagging = false
				end
				if (P_IsObjectInGoop(knux))
					if knuckles.digging
						knuckles.pflags = $&~PF_JUMPED
						knux.state = S_PLAY_FALL
						knuckles.digging = 0
					end
				end
                if not (knuckles.smhyper)
                    knuckles.pflags = $&~PF_GODMODE
                end
				if (knux.eflags & MFE_SPRUNG)
					if (knuckles.digging or knuckles.spike_breaktime)
						S_StartSound(knux, sfx_sprong)
						knuckles.pflags = $&~PF_JUMPED
						knuckles.digging = 0
						knuckles.spike_breaktime = 0
						knux.state = S_PLAY_FALL
						knux.momz = $*40/33
					end
				end
				if (P_PlayerInPain(knuckles))
					if knuckles.digging
						knuckles.pflags = $&~PF_JUMPED
						knuckles.digging = 0
						P_DoPlayerPain(knuckles, nil, nil)
					end
				end
				if S_SoundPlaying(knux, sfx_s3kd3l) 
				and not (knuckles.digging)
					S_StopSoundByID(knux, sfx_s3kd3l)
				end
				if not (knuckles.digging)
                    knuckles.charability2 = CA2_SPINDASH
                    knuckles.pflags = $&~PF_NOCLIP
				end
				if (knuckles.digging == 1)
					P_SpawnGhostMobj(knux)
					P_SetObjectMomZ(knux, -25*FRACUNIT, false)
					knuckles.powers[pw_nocontrol] = 10
					knux.momx = 0
					knux.momy = 0
					knuckles.charability2 = CA2_NONE
					if P_IsObjectOnGround(knux) or knux.eflags & MFE_JUSTHITFLOOR
						knuckles.digging = 2
					end
					if not (knux.state >= S_PLAY_DIG1 and knux.state <= S_PLAY_DIG4)
						knux.state = S_PLAY_DIG1
						S_StartSound(knux, sfx_zoom)
					end
				end
				if (knuckles.digging == 2)
					knux.momz = 0
					local nextsec = R_PointInSubsector(knux.x + knux.momx, knux.y + knux.momy).sector
					for rover in nextsec.ffloors() do
						if (rover.bottomheight < knux.z + P_GetPlayerHeight(knuckles)) and (rover.topheight > knux.z) then
							if (rover.flags & (FF_TRANSLUCENT|FF_SOLID) == (FF_TRANSLUCENT|FF_SOLID)) then
								rover.flags = $1 & ~FF_SOLID
							end
						end
					end
					if ((leveltime % TICRATE == 0))
						knuckles.digtime = $ - TICRATE
					end
					knux.sprite = 0
					knux.sprite2 = 0
					knux.panim = PA_WALK
					knux.flags = $|MF_NOCLIPTHING
					knuckles.skidtime = 0
					knuckles.pflags = $|PF_GODMODE&~PF_JUMPED&~PF_SPINNING
					if (not nextsec or (nextsec.ceilingheight - nextsec.floorheight <= knux.height)) then
						P_TryMove(knux, knux.x, knux.y, false)
						knux.angle = -knux.angle
					end
                    if not S_SoundPlaying(knux, sfx_s3kd3l) 
                    and (knuckles.speed)
                        S_StartSound(knux, sfx_s3kd3l)
                    end
                    if S_SoundPlaying(knux, sfx_s3kd3l) 
                    and not (knuckles.speed)
                        S_StopSoundByID(knux, sfx_s3kd3l)
                    end
					if ((leveltime % 4 == 0)) and (knuckles.cmd.forwardmove or knuckles.cmd.sidemove)
						local randomXY = P_RandomRange(-39,39)*FRACUNIT
						local debris = P_SpawnMobj(knux.x+(P_RandomRange(49,-49)*FRACUNIT),knux.y+(P_RandomRange(49,-49)*FRACUNIT),knux.z,MT_MINUSDIRT)
						debris.angle = knuckles.drawangle*ANGLE_90
						local debrisX = knux.x + P_ReturnThrustX(knux, debris.angle, knux.radius + debris.radius)
						local debrisY = knux.y + P_ReturnThrustY(knux, debris.angle, knux.radius + debris.radius)
					end
					if not (P_IsObjectOnGround(knux)) or player.pflags & PF_JUMPDOWN or (knuckles.digtime == 0) or player.finished
						if knuckles.digging and (knux and knux.valid)
							S_StopSoundByID(knux, skins["knuckles"].soundsid[SKSJUMP])
							P_SetObjectMomZ(knux, 4*FRACUNIT, false)
							P_SpawnMobj(knux.x, knux.y, knux.z, MT_DUST)
							S_StartSound(knux, sfx_s3k82)
							knuckles.digging = 0						
							knux.state = S_PLAY_FALL
							knux.flags = $ &~MF_NOCLIP&~MF_NOCLIPTHING&~MF_NOCLIPHEIGHT
							knuckles.pflags = $ &~PF_GODMODE&~PF_JUMPED&~PF_SPINNING&~PF_NOCLIP
						end
					end
					if (knuckles.cmd.buttons & BT_TOSSFLAG)
						if (knuckles.tossflagging == false)
							P_SetObjectMomZ(knux, 17*FRACUNIT, false)
							knux.state = S_PLAY_DIGU1
							knux.flags = $ &~MF_NOCLIP&~MF_NOCLIPTHING&~MF_NOCLIPHEIGHT
							knuckles.pflags = $ &~PF_GODMODE&~PF_NOCLIP
							knuckles.digging = 0
							knuckles.spike_breaktime = 13
							S_StartSound(knux, sfx_crumbl)
							for i = 1, 17
								local dust = P_SpawnPlayerMissile(knux, MT_BOSSJUNK, MF2_SCATTER)
								dust.flags = $|MF_BOUNCE|MF_GRENADEBOUNCE|MF_MISSILE
								dust.tics = 100
								dust.sprite = SPR_ROIA
								dust.frame = A
								dust.eflags = player.mo.eflags & MFE_VERTICALFLIP
								P_InstaThrust(dust, i*ANGLE_22h, 5*player.mo.scale)
								dust.momz = 16*P_MobjFlip(player.mo)*player.mo.scale
							end
						end
					end
					if player.powers[pw_super]
						player.digtime = DIG_TIME
					end
				end
			end
		end
	end
end)

addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.valid and player.mo.skin == "knuckles"
	and (player.spike_breaktime)
		return true
	end
end)

local function hudstuff2(v, player, cam)
	if (player.mo and player.mo.skin == "knuckles" and player.digtime != nil)
		v.drawString(18, 155, "Dig Time:", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_YELLOWMAP|V_HUDTRANS|V_PERPLAYER)
		if not player.powers[pw_super] or player.mysticsuper
			v.drawString(18,165, player.digtime/TICRATE+"/9\x82 SECONDS", 
			V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		else
			v.drawString(18,165,"\x82 SECONDS", 
			V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		end
	end
end
hud.add(hudstuff2, player)

local function SkipDuck(player)
	if player.mo and player.mo.valid and player.mo.skin == "knuckles"
		if player.digging
			return P_GetPlayerSpinHeight(player)/2
		end
	end
end
addHook("PlayerHeight", SkipDuck)
addHook("PlayerCanEnterSpinGaps", SkipDuck)