//Start

addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.valid
		if player.mo.skin == "sonic" and not player.smhyper and not player.darkform
			if P_LookForEnemies(player)
				player.actionspd = 100*FRACUNIT
				player.charability = CA_HOMINGTHOK
			elseif not (player.pflags & PF_THOKKED) and not (player.mo.eflags & MFE_UNDERWATER) and not player.doublejumped //You cant speed thok but you can speed homing attack
				player.actionspd = 60*FRACUNIT
				P_InstaThrust(player.mo, player.mo.angle, player.actionspd)
				player.drawangle = player.mo.angle
				S_StartSound(player.mo, sfx_thok, player)
				P_SpawnThokMobj(player)
				player.pflags = $ | PF_THOKKED
			elseif not (player.pflags & PF_THOKKED) and (player.mo.eflags & MFE_UNDERWATER) and not player.doublejumped
				player.actionspd = 60*FRACUNIT
				P_InstaThrust(player.mo, player.mo.angle, player.actionspd / 2)
				player.drawangle = player.mo.angle
				S_StartSound(player.mo, sfx_thok, player)
				P_SpawnThokMobj(player)
				player.pflags = $ | PF_THOKKED
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.mo.skin == "sonic"
			
			if (player.mo.state == S_PLAY_SPRING
			or player.mo.state == S_PLAY_FALL)
			and (player.pflags & PF_THOKKED)
			and not player.doublejumped
				player.mo.state = S_PLAY_ROLL
				player.pflags = $ | PF_JUMPED
			end
		end
	end
end)

//Start
freeslot("sfx_sprflt")

addHook("ThinkFrame", do
 for player in players.iterate
	if player.mo and player.mo.valid
		if player.mo.skin == "sonic" and player.playerstate == PST_LIVE
        
            if player.powers[pw_super]
                if player.cmd.buttons & BT_CUSTOM3
                and player.pflags & PF_JUMPED
                and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
                and not (player.pflags & (PF_SPINNING | PF_SHIELDABILITY))
                and not player.climbing
                and player.mo.momz*P_MobjFlip(player.mo) < 0
                    if player.panim != PA_WALK and player.panim != PA_RUN
                        if player.speed >= FixedMul(player.runspeed, player.mo.scale)
                            player.mo.state = S_PLAY_FLOAT_RUN
                        else
                            player.mo.state = S_PLAY_FLOAT
                        end
                    end
                    
                    if player.speed > 5*player.mo.scale
                        player.mo.momz = 0
                    end
                    player.pflags = $ &~ PF_STARTJUMP | PF_NOJUMPDAMAGE
                end
            end
            
            if not player.powers[pw_super]
		
                if player.doublejumped
                and CheckIfCanExecute(player)
                and player.mo.momz <= 0 
                and not (player.mo.state == S_PLAY_FALL)
                and not (player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(player.mo))
                    player.pflags = $&~PF_JUMPED
                    player.mo.state = S_PLAY_FALL
                end
            
                    if player.cmd.buttons & BT_TOSSFLAG
                    and (player.pflags & PF_JUMPED)
                    and (CheckIfCanExecute(player))
                    and not (player.pflags & PF_THOKKED)
                        if not player.doublejumped
                            player.mo.momz = 0
                            player.pflags = $|PF_THOKKED
                            player.pflags = $&~PF_SPINNING
                            player.doublejumped = 1
                        end
                    end
                        if player.doublejumped and not player.doublestopper
                            S_StartSound(player.mo, sfx_cdfm02)
                            P_CreateRingOfItems(player, 17, MT_MEDIUMBUBBLE, MT_SPINDUST, 13, -2)
                            player.mo.state = S_PLAY_ROLL
                        if not (player.mo.eflags & MFE_UNDERWATER)
                            player.mo.momz = (10*P_MobjFlip(player.mo))*player.mo.scale;
                        else
                            player.mo.momz = (7*P_MobjFlip(player.mo))*player.mo.scale;
                        end
                            player.doublestopper = 1
                        end
                    if P_IsObjectOnGround(player.mo) or player.mo.state == S_PLAY_PAIN or player.mo.eflags & MFE_JUSTHITFLOOR
                        player.doublestopper = 0
                        player.doublejumped = 0
                        player.airtime = 0
                    end
                end
			end
		end
	end
end)

//Disabled
freeslot("sfx_sboost","sfx_sbostw","sfx_swind")

--FixedLerp
local function FixedLerp(a, b, w)
    return FixedMul((FRACUNIT - w), a) + FixedMul(w, b)
end

local function SmoothTrail(mo, trailmo, freq)
    -- Real Z momentum thingy plus leveltime checks.
    -- You can replace all this with mo.momz+mo.pmomz but that stays at 0 when on slopes and on ground.
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    -- Handy local variables.
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    -- The loop, repeats until it spawns all the thok objects.
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
        spawnedmo.color = mo.color
        spawnedmo.blendmode = AST_ADD -- blend
    end
end

addHook("PlayerThink", function(player)
    if player and player.valid and player.mo and player.mo.valid then
		if player.sboosting then
            SmoothTrail(player.mo, MT_THOK, 4*FRACUNIT)
		end
    end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		local mo = player.mo
		if not (mo and mo.valid and mo.skin == "sonic") continue end
		if (player == nil) or (player.playerstate != PST_LIVE) continue end
		
		if (mo.previousx == nil) or (mo.previousy == nil) or (mo.previousz == nil)
			mo.previousx = mo.x
			mo.previousy = mo.y
			mo.previousz = mo.z
		end  
        if not (player.cmd.buttons & BT_ATTACK)
            player.dontallowfire = false
        else
            player.dontallowfire = true
        end
        
		if player.sboosting
			local boost_fire = P_SpawnGhostMobj(mo)
			boost_fire.tics = 1
			boost_fire.fuse = 2
			boost_fire.sprite = SPR_FIRS
			boost_fire.frame = S|FF_FULLBRIGHT
			boost_fire.color = mo.color
			boost_fire.flags = $|MF_MISSILE
			boost_fire.flags2 = $|MF2_SCATTER
			boost_fire.colorized = true
			boost_fire.blendmode = AST_ADD
			P_TeleportMove(boost_fire, mo.x, mo.y, mo.z + 7 * FRACUNIT)
		end
		mo.previousx = mo.x
		mo.previousy = mo.y
		mo.previousz = mo.z
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
	 if player.mo and player.mo.valid
		if player.mo.skin == "sonic" and player.playerstate == PST_LIVE
		
			local pmo = player.mo
			local mo = pmo
			
			local normalspeed = skins["sonic"].normalspeed
			local boostspeed = 85*FRACUNIT
			local hyperspeed = 100*FRACUNIT
            
            if not player.dontallowfire
				player.dontallowfire = false
			end
            if not player.sound_play
                player.sound_play = 0
            end
			if not player.aerial_boosted
				player.aerial_boosted = false
			end
            if not player.justfrickinboosted
                player.justfrickinboosted = 0
            else
                player.justfrickinboosted = $ - 1
            end
			
				if (player.cmd.buttons & BT_CUSTOM1)
				and CheckIfCanExecute(player)
				and not player.skidtime
				and not player.aerial_boosted
				and not (player.pflags & PF_SPINNING)
                and not (player.boost_tapping)
				and (player.cmd.forwardmove or player.cmd.sidemove)
					if not (player.sboosting)
						player.sboosting = true
                        player.justfrickinboosted = 10
						pmo.momz = 0
						P_InstaThrust(pmo, pmo.angle, 85*FRACUNIT)
						S_StartSound(pmo, sfx_sboost)
                        S_StartSound(pmo, sfx_sbostw)
						if not P_IsObjectOnGround(pmo)
							player.aerial_boosted = true
						end
					end
				end
                if player.boost_tapping == nil then
                    player.boost_tapping = false
                end 
                -- Stores the player's speed angle.
                if player.speed > player.normalspeed then
                    player.momangle2 = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
                else
                    player.momangle2 = player.mo.angle
                end
                if not (player.cmd.buttons & BT_CUSTOM1)
                    player.boost_tapping = false
                else
                    player.boost_tapping = true
                end 
                if (player.boost_tapping == false)
                and not (player.cmd.buttons & BT_CUSTOM1)
                    player.sboosting = false
                    S_StopSoundByID(pmo, sfx_sbostw)
                end
                if player.sboosting
                    player.drawangle = player.momangle2
                    if player.speed < (boostspeed) then
                        P_Thrust(player.mo, player.momangle2, boostspeed - player.speed)
                    end
                    if not player.cmd.forwardmove then
                        player.cmd.forwardmove = 50 --Intentionally not in PreThinkFrame
                    end
                end
                if player.sboosting
                and not S_SoundPlaying(pmo, sfx_swind)
                    S_StartSound(pmo, sfx_swind)
                end
				if not player.sboosting
				and S_SoundPlaying(pmo, sfx_sbostw)
					S_StopSoundByID(pmo, sfx_sbostw)
				end
                if not player.sboosting
				and S_SoundPlaying(pmo, sfx_swind)
					S_StopSoundByID(pmo, sfx_swind)
				end
				if not player.sboosting
				and player.normalspeed == boostspeed or player.normalspeed == hyperspeed
					player.normalspeed = normalspeed
                    player.sound_play = 0
				end
				if player.sboosting
				and CheckIfCanExecute(player)
					if not player.smhyper
						player.normalspeed = boostspeed
					else
						player.normalspeed = hyperspeed
					end
				end
				if player.sboosting
				and CheckIfCanExecute(player)
				and P_IsObjectOnGround(pmo)
					player.speedtimer = 60
                        if (player.sound_play >= 20)
                            player.sound_play = 200
                        else
                            player.sound_play = $+1
                        end
					end
				if P_IsObjectOnGround(pmo) or player.hflying
					player.aerial_boosted = false
				end
				if (P_PlayerInPain(player) or player.speed < player.runspeed or player.panim == PA_WALK)
                and not (player.justfrickinboosted)
					player.sboosting = false
				end
			end
		end
	end
end)

addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.valid and player.mo.skin == "sonic"
	and (player.sboosting)
		return true
	end
end)