

addHook("ThinkFrame", do
	for player in players.iterate
	 if player.mo and player.mo.valid
		if player.mo.skin == "sonic"
		
		local pmo = player.mo
		
		if not player.tappingtossflag
			player.tappingtossflag = false
		end
		
		if player.holdingflightbutton == nil
			player.holdingflightbutton = false
		end
		
		if player.powers[pw_super]
		
			if not player.hflying
					player.hflying = false
				end
		
				if ((player.cmd.buttons & BT_JUMP) or (player.cmd.buttons & BT_USE))
					player.holdingflightbutton = true
				else
					player.holdingflightbutton = false
				end
				
				if player.cmd.buttons & BT_TOSSFLAG
				and (player.pflags & PF_JUMPED or player.hflying or (pmo.state == S_PLAY_FALL or pmo.state == S_PLAY_SPRING))
				and not P_PlayerInPain(player)
				and not player.powers[pw_carry]
				and not (player.exiting)
					if (player.tappingtossflag ~= true)
						if (player.hflying == false)
							player.hflying = true
						else
							player.hflying = false
							pmo.state = S_PLAY_FALL
							pmo.flags = $ &~MF_NOGRAVITY
						end
					end
				end
				
				if player.cmd.buttons & BT_TOSSFLAG
					player.tappingtossflag = true
				else
					player.tappingtossflag = false
				end
				
						if (P_IsObjectOnGround(pmo))
						and player.hflying
							pmo.flags = $ &~MF_NOGRAVITY
							player.hflying = false
						end
                        
                        if player.hflying
                            player.pflags = $|PF_CANCARRY
                        else
                            player.pflags = $&~PF_CANCARRY
                        end
				
					
						if player.hflying
						if (pmo.state == S_PLAY_JUMP or (pmo.state == S_PLAY_FALL or pmo.state == S_PLAY_SPRING))
							pmo.state = S_PLAY_FLOAT
						end
						pmo.flags = $|MF_NOGRAVITY
						player.pflags = $&~PF_JUMPED
						
						if (player.cmd.buttons & BT_JUMP)
							if (pmo.momz < 20*FRACUNIT)
								P_SetObjectMomZ(pmo, FRACUNIT, true)
								player.holdingflightbutton = true
							end
						end
						if (player.cmd.buttons & BT_USE)
							if (pmo.momz > -20*FRACUNIT)
								P_SetObjectMomZ(pmo, -FRACUNIT, true)
								player.holdingflightbutton = true
							end
						end
					end
					if player.hflying
						if not (player.cmd.forwardmove or player.cmd.sidemove)
							pmo.momx = $*30/31
							pmo.momy = $*30/31
						end
						if (player.holdingflightbutton ~= true)
							if ((pmo.momz >= -pmo.scale) and (pmo.momz <= pmo.scale))
								pmo.momz = 0
							elseif not ((pmo.momz >= -pmo.scale) and (pmo.momz <= pmo.scale))
								if (player.holdingflightbutton ~= true)
									pmo.momz = $*30/31
								end
							end
						end	
					end
				end
		
			if player.smhyper
            local p = player
            local mo = pmo
            
                    if (S_MusicName() == "_super")
                        if (player.hyper_music == true)
                            P_PlayJingleMusic(player, "SSHYP", 0, true, JT_OTHER)
                        end
                    end
            
                    if not pmo.prevcolor
                        pmo.prevcolor = SKINCOLOR_WHITE
                    end
                    pmo.color = pmo.prevcolor
		
					if ((leveltime))
						if player.hyper_colorized	
                            -- conditions where we should *not* colour shift
                            if ((gametyperules & GTR_TEAMS) and player.ctfteam)	-- no confusion in team gamemodes
                            or (pmo.frame & FF_TRANSMASK) -- multiple ghosts stacking will make us more opaque, so lets prevent it by removing it outright
                                mo.hyper_shifttimer = nil
                                return
                            end
                            if (p.hyper_colourshift_delay)
                                p.hyper_colourshift_delay = $-1
                            else
                                mo.hyper_shifttimer = $ or 0
                            end
                            if (mo.hyper_shifttimer != nil)	-- if it's not nil, we can start
                                -- get the colour table
                                p.hyper_shiftcolors = $ or extrachars.ColourShiftDefault
                                
                                -- handle the timer and get maxindex
                                pmo.hyper_shifttimer = $+1
                                local shifttics = extrachars.ColourShiftTics
                                local maxindex = #p.hyper_shiftcolors + 1
                                
                                -- the start colour, what we're fading FROM
                                local startindex = (pmo.hyper_shifttimer / shifttics) % maxindex	-- get startindex
                                local start = P_SpawnGhostMobj(pmo)
                                start.frame = ($ & ~FF_TRANSMASK)
                                start.rollangle = mo.rollangle
                                start.color = p.hyper_shiftcolors[startindex] or mo.color
                                start.tics = 1
                                
                                -- the shift colour, what we're fading TO
                                local fade = max(1, min(10, 10 - (((mo.hyper_shifttimer % shifttics) * 10) / shifttics)))
                                
                                local shift	-- define here so it's usable outside the block
                                if (fade >= 1 and fade <= 9)
                                    local shiftindex = ((mo.hyper_shifttimer + shifttics) / shifttics) % maxindex	-- get shiftindex
                                    shift = P_SpawnGhostMobj(mo)
                                    shift.frame = ($ & ~FF_TRANSMASK) | (fade << FF_TRANSSHIFT)
                                    shift.rollangle = mo.rollangle
                                    shift.color = p.hyper_shiftcolors[shiftindex] or mo.color
                                    shift.tics = 1
                                    pmo.prevcolor = p.hyper_shiftcolors[shiftindex]
                                end
                                
                                -- hide them if we arent visible
                                if (mo.flags2 & MF2_DONTDRAW)	
                                    -- we want to hide them instead of preventing them from being spawned to prevent desync
                                    start.flags2 = $|MF2_DONTDRAW
                                    if (shift and shift.valid)
                                        shift.flags2 = $|MF2_DONTDRAW
                                    end
                                end
                                
                                if (mo.hyper_shifttimer == ((shifttics * maxindex) - 1))
                                    mo.hyper_shifttimer = nil
                                end
                            end
						end
						/*local shiny_body = P_SpawnGhostMobj(pmo)
						shiny_body.color = SKINCOLOR_SILVER
						shiny_body.blendmode = AST_ADD
						P_TryMove(shiny_body, pmo.x, pmo.y, true)*/
                        local colorsthatmakeshadowdie = extrachars.ColourShiftDefault
						if (player.speed > 2*FRACUNIT or pmo.momz > 2*FRACUNIT or pmo.momz < -1*FRACUNIT)
                            local afterimage = P_SpawnGhostMobj(pmo)
                            afterimage.color = (colorsthatmakeshadowdie[P_RandomRange(1,7)])
                            afterimage.colorized = true
                            afterimage.rollangle = pmo.rollangle
                            afterimage.fuse = 5
                            afterimage.blendmode = AST_ADD
                            afterimage.eflags = pmo.eflags & MFE_VERTICALFLIP
                            afterimage.source = pmo
							//pmo.state = S_PLAY_FLOAT_RUN
						end
					end
				end
			end
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.valid
		if player.mo.skin == "sonic" and player.smhyper
			if P_LookForEnemies(player)
				P_FlashPal(player, PAL_WHITE, 2)
				S_StartSound(player.mo, sfx_zoom, player)
				player.actionspd = 170*FRACUNIT
				player.charability = CA_HOMINGTHOK
                P_TeleportMove(player.mo, player.mo.target.x, player.mo.target.y, player.mo.target.z)
			elseif not (player.pflags & PF_THOKKED) and not (player.mo.eflags & MFE_UNDERWATER) and not player.doublejumped //You cant speed thok but you can speed homing attack
				player.actionspd = 60*FRACUNIT
				player.drawangle = player.mo.angle
				S_StartSound(player.mo, sfx_thok, player)
				P_SpawnThokMobj(player)
				P_InstaThrust(player.mo, player.mo.angle, player.actionspd*2)
				player.mo.momz = 0 * FRACUNIT
				P_FlashPal(player, PAL_WHITE, 3)
				P_NukeEnemies(player.mo, player.mo, 1214*FRACUNIT)
				S_StartSound(player.mo, sfx_zoom, player)
				player.pflags = $ | PF_THOKKED
			end
		end
	end
end)

addHook("ShouldJingleContinue", function(player, musname)
    if musname != "sshyp" return end
    if (player.smhyper)
        return true
    else
        return false
    end
end)

local windows124
addHook("PreThinkFrame", function(r)
	windows124 = S_GetMusicPosition()
end)

addHook("MusicChange", function(sus, mogus)
	if (gamestate != GS_LEVEL) or (consoleplayer.hyper_music ~= true) return end
	if (consoleplayer and consoleplayer.mo 
	and consoleplayer.mo.valid and consoleplayer.mo.health
	and consoleplayer.smhyper)
	and (mogus == "_shoes" or mogus == "_inv" or mogus == "_minv" or mogus == mapmusname)
		if sus == "sshyp"
			return true
		else
			return "sshyp", 0, true, windows124
		end
	end
end)